<?php
/*
Elite-Board 2.0, 2.1
Модуль для блокировки доступа к сайту пользователей из списка подсетей госорганов
версия модуля 130827
*/

$updlink = 'http://illusionweb.ru/board_support/blacklist.txt'; // список подсетей на удаленном сервере
$timeout = 86400;  // время кэширования списка
$file = FULLPATH . 'commands/blacklist.txt';    // локальный список
$link = ''; // ссылка для перенаправления, например http://antizapret.info, если ничего не указано, будет просто 404 ошибка
$enable_module = true;


if($enable_module){
    $ip = $settings['ip'];
    $denied = false;
    
    // Функция проверки вхождения IP-адреса в подсеть
    // http://mycrimea.su/partners/web/access/ipsearch.php
    function ip_search($ip, $net, $mask)
    {
        // Преобразование IP в беззнаковое число:
        $net2 = $net;
        $ip = ip2long($ip);
        $mask = ip2long($mask);
        $net = ip2long($net);
    
        if (($ip & $mask) == $net) {
            return true;
        } else {
            return false;
        }
    }
    // Поскольку подсети записаны в формате 127.0.0.0/8, то понадобится функция перевода CIDR в обычную маску: 127.0.0.0/255.0.0.0:
    function cidr($mask)
    {
        return long2ip(pow(2, 32) - pow(2, (32 - $mask)));
    }
    
    // Если файл существует:
    if (is_file($file)) {
        // Считываем файл в массив:
        $base = file($file);
        
        if(time() - filemtime($file) > $timeout || count($base) == 0){
            if(is_writable($file)){
                if($newinf = @file_get_contents($updlink)){
                    if(!strstr('<!DOCTYPE html>', $newinf)){
                        @file_put_contents($file, $newinf); 
                    }
                }   
            }else{
                pr('Не получается кэшировать список, требуются права на запись');
            }
        }
        
        // Проходим массив циклом:
        $all = sizeof($base);
        for ($i = 0; $i < $all; $i++) {
            // Если строка существует:
            if ($base[$i]) {
                    $line = trim($base[$i]);            
                    // Разбиваем строку на массив, в качестве значений используются адрес и маска подсети:
                    $line = explode('/', $line);
        
                    if(isset($line[1])){
                        $mask = $line[1];
                        // Переводим CIDR в обычную маску:
                        $mask = cidr($mask);
                        $net = $line[0];
                        // Проверяем вхождение IP-адреса в подсеть:
                        if (ip_search($ip, $net, $mask)) {
                            $denied = true;
                            break;
                    }                
                }else{
                    // в списке может быть и просто один ip адрес
                    if($ip == $line[0]){
                        $denied = true;              
                    }                          
                }     
            }
        }
        if($denied){
            if($link == ''){
        		header("HTTP/1.1 404 Not Found");
        		header("Status: 404 Not Found");   
            }else{
                header('Location: ' . $link);
            }
            exit();
        }
    }
}


?>